#ifndef ATTRIBUTEVIEW_H
#define ATTRIBUTEVIEW_H

#include <Control.h>
#include <string>
#include <list>

class AttributeView : public BControl {
	public:
				inline		AttributeView(BRect frame, const char *name,
								const char *label, BMessage *message,
								uint32 resizeMode, uint32 flags) :

								BControl(frame, name, label, message, resizeMode,
									flags) {};
		virtual	inline		~AttributeView(void) {};
		
		virtual void		SetAlignment(alignment label, alignment input) = 0;
		virtual void		GetAlignment(alignment *label, alignment *input) = 0;
		
		virtual void		SetDivider(float x) = 0;
		virtual float		Divider(void) const = 0;
		
		virtual uint32		Length(void) = 0;
		virtual const char *Value(void) = 0;
		virtual bool		HasChanged(void) = 0;
		
		virtual status_t	SetValue(const char *value, uint32 length) = 0;
		
		virtual void		SetEnabled(bool) = 0;
};

extern "C" AttributeView *instantiate_view(const char *name, const char *label, uint32 type,
	const char *contents, uint32 length);
extern "C" bool supports(uint32 type, const char *name);

#endif
